<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
        <el-form-item label="畜种" prop="animalType">
          <el-select v-model="queryParams.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="暂存日期" prop="timeRange">
          <el-date-picker
            v-model="queryParams.timeRange"
            type="daterange"
            value-format="yyyy-MM-dd"
            range-separator="至"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            :picker-options="pickerOptions"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="暂存批次号" prop="harmlessTreatmentId">
          <el-input
            v-model="queryParams.harmlessTreatmentId"
            placeholder="请输入暂存批次号"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:harmless:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['app:harmless:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading" ref="multipleTable" :data="disposalList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <!--  <el-table-column label="ID"  prop="id" width="80" />  -->
        <el-table-column label="暂存日期"  prop="storeTime" />
        <el-table-column label="暂存批次号"  prop="harmlessTreatmentId" />
        <el-table-column label="畜种">
          <template slot-scope="scope">
            {{animalName(scope.row.animalType)}}
          </template>
        </el-table-column>
        <el-table-column label="暂存产品"  prop="productName" >
        </el-table-column>
        <el-table-column label="暂存产品数量"  prop="illnessAmount" >
          <template slot-scope="scope">
            <span>{{ scope.row.illnessAmount }} {{ scope.row.unit }}</span>
          </template>
        </el-table-column>
        <el-table-column label="约当重量"  prop="unqualifiedWeight" >
          <template slot-scope="scope">
            <span>{{ scope.row.unqualifiedWeight }} kg</span>
          </template>
        </el-table-column>
        <el-table-column label="暂存位置"  prop="storeLocation" >
          <template slot-scope="scope">
            <div>
              <span>{{scope.row.storeLocation}}</span>
              <el-tag type="primary" size="mini" v-if="scope.row.isLeave === 0">(在库)</el-tag>
              <el-tag type="danger" size="mini" v-else-if="scope.row.isLeave === 1">(已转运)</el-tag>
            </div>
          </template>
        </el-table-column>
        <el-table-column label="责任人"  prop="userName" />
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              style="margin-right: 10px"
              v-hasPermi="['app:harmless:edit']"
            >修改</el-button>
            <el-popconfirm
              v-hasPermi="['app:harmless:remove']"
              :title="'是否确认删除所选数据项？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
              >删除</el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="550px" append-to-body>
      <el-form ref="form" label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="120px">
        <el-form-item label="暂存日期" prop="storeTime">
          <el-date-picker
            style="width: 100%"
            v-model="form.storeTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择日期时间">
          </el-date-picker>
        </el-form-item>
<!--        <el-form-item label="无害化批次号" prop="harmlessTreatmentId">-->
<!--          <el-select v-model="form.harmlessTreatmentId" placeholder="请选择无害化批次号">-->
<!--            <el-option v-for="item in harmlessList" :key="item.id" :value="item.id" :label="item.id"></el-option>-->
<!--          </el-select>-->
<!--          <el-input v-model="form.harmlessTreatmentId"  placeholder="请填写无害化批次号"></el-input>-->
<!--        </el-form-item>-->
        <!-- <el-form-item  label="暂存头数" prop="illnessAmount">
          <el-input v-model="form.illnessAmount"  :placeholder="isView ? '' : '请填写暂存头数'">
            <template #append>头</template>
          </el-input>
        </el-form-item> -->
        <el-form-item label="畜种" prop="animalType">
          <el-select v-model="form.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item  label="暂存产品" prop="productName">
          <el-radio-group v-model="form.productName" >
            <el-radio v-for="item in productionList" :key="item.id" :label="item.productName" class="large_radio">{{item.productName}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item  label="暂存数量" prop="illnessAmount">
          <el-input  v-model="form.illnessAmount" placeholder="">
            <template #append>
              <span>{{form.unit}}</span>
            </template>
          </el-input>

        </el-form-item>
        <el-form-item label="约当重量" prop="unqualifiedWeight">
          <el-input  disabled v-model="form.unqualifiedWeight" placeholder="">
            <template #append>
              <span>千克</span>
            </template>
          </el-input>
        </el-form-item>
        <el-form-item  label="暂存位置" prop="storeLocation">
          <el-select v-model="form.storeLocation" style="width: 100%">
            <el-option v-for="item in workList" :key="item.id" :value="item.workshopName" :label="item.workshopName"></el-option>
          </el-select>
<!--          <el-input v-model="form.storeLocation"  placeholder="请输入暂存位置"></el-input>-->
        </el-form-item>
        <el-form-item  label="责任人" prop="userName">
          <el-input v-model="form.userName" show-word-limit maxlength="10" placeholder="请输入责任人"></el-input>
        </el-form-item>
        <!--        <el-form-item label="处理方式" prop="dealWay">-->
        <!--          <el-input type="textarea" :autosize="{ minRows: 2 }"   v-model="form.dealWay" maxlength="50" show-word-limit placeholder="请输入处理方式" />-->
        <!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { listAllHarmlessTreatment } from "../../../api/app/harmlessTreatment";
import { getHarmlessPage, getHarmlessDetail, addHarmlessPage, editHarmlessPage, delHarmlessPage } from "../../../api/app/harmless";
import {formatDate, getFindByKey, changeDate} from "../../../utils";
import { required, rules } from "../../../utils/formRules";
import {getUserProfile} from "../../../api/system/user";
import { getWorkshopList } from "../../../api/app/workshop";
import { listProductCategoryAll } from "../../../api/app/productCategory";
import {mapState} from "vuex";
export default {
  name: "",
  data() {
    // 验证15位数字
    const validateNumber = (rule, value, callback) => {
      if (!/^([1-9]\d*(\.\d{1,2})?|0\.(\d[1-9]|[1-9]\d))$/.test(value)) {
        callback(new Error('必须是正数且最多两位小数'));
      } else {
        callback();
      }
    };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        harmlessTreatmentId: null,
        startTime: null,
        endTime: null,
        animalType: null
      },
      pickerOptions: {
        disabledDate(time) {
          // 获取当前日期
          const today = new Date();
          today.setHours(0, 0, 0, 0); // 将时间设置为当天的 00:00:00

          // 禁用今天之后的日期
          return time.getTime() > today.getTime();
        }
      },
      // 表单参数
      form: {
        harmlessTreatmentId: null,
        id: null,
        illnessAmount: null,
        productName:null,
        storeLocation: null,
        storeTime: changeDate(new Date()),
        unqualifiedWeight: null,
        unit:null,
        userName: null,
        animalType: null
      },
      rules: {
        storeTime: [required('暂存日期不能为空')],
        harmlessTreatmentId: [required('无害化批次号不能为空')],
        // unqualifiedWeight: [required('暂存重量不能为空'), rules.decimals],
        storeLocation: [required('暂存位置不能为空')],
        userName: [required('责任人不能为空')],
        illnessAmount: [
          {
            validator: (rule, value, callback) => {
              if (!value) {
                // 如果没填，直接通过
                return callback();
              }
              validateNumber(rule, value, callback);
            },
            trigger: 'blur'
          }
        ],
        unqualifiedWeight: [
          {
            validator: (rule, value, callback) => {
              if (!value) {
                // 如果没填，直接通过
                return callback();
              }
              validateNumber(rule, value, callback);
            },
            trigger: 'blur'
          }
        ]
      },
      harmlessList: [],
      user: {},
      workList: [],
      // 产品名称列表
      productionList: [],
      isFromDetail: false
    }
  },
  watch: {
    "queryParams.timeRange": {
      handler(newVal) {
        if (newVal) {
          this.queryParams.startTime = newVal[0]
          this.queryParams.endTime = newVal[1]
        } else {
          this.queryParams.startTime = null
          this.queryParams.endTime = null
        }
      },
      deep: true
    },
    "form.productName": {
      handler(newVal) {
        this.productionList.forEach(item => {
          if(item.productName === newVal) {
            this.form.unit = item.unit
            this.form.weight = item.eqWeight
          }
        })
      },
      deep: true
    },
    "form.illnessAmount": {
      handler(newVal) {
        if(this.form.weight) {
          this.form.unqualifiedWeight = newVal * this.form.weight
        } else {
          this.form.unqualifiedWeight = newVal
        }
      },
    },
    "form.animalType": {
      handler(newVal, oldVal) {
        this.getProduction()
      },
      deep: true,
    }
    // "form.harmlessTreatmentId": {
    //   handler(newVal) {
    //     if (newVal) {
    //       let item = getFindByKey(this.harmlessList, newVal, 'id')
    //       if (item) {
    //         this.form.illnessAmount = item.illnessDeadAmount + item.illnessDiseaseAmount
    //         this.form.unqualifiedWeight = item.unqualifiedWeight
    //       }
    //     } else {
    //       this.form.illnessAmount = null
    //       this.form.unqualifiedWeight = null
    //     }
    //   },
    //   deep: true
    // }
  },
  computed: {
    ...mapState({
      animalList: state => state.user.animalList
    }),
    animalName() {
      return (value) => {
        if (value === null) return '未知'
        const animal = this.animalList.find(item =>
          String(item.typeValue) === String(value)
        )
        return animal ? animal.typeName : '未知'
      }
    }
  },
  created() {
    this.getUser()
    this.getWork()
    this.getHarmlessList()
    this.getList();
    this.getProduction();
  },
  methods: {
    /** 产品列表 **/
    getProduction() {
      if (this.isFromDetail) return;
      if(this.form.animalType === null) return;
      let params = {
        animalType: this.form.animalType
      }
      listProductCategoryAll(params).then(res => {
        this.productionList = res.rows
      })
    },
    /** 仓库列表 **/
    getWork() {
      let params = {
        workshopType: 6
      }
      getWorkshopList(params).then(res => {
        this.workList = res.data
      })
    },
    /** getUser **/
    getUser() {
      getUserProfile().then(response => {
        this.user = response.data;
        this.form.userName = response.data.nickName
      });
    },
    /** 无害化批次号列表 **/
    getHarmlessList() {
      listAllHarmlessTreatment().then(res => {
        this.harmlessList = res.rows
      })
    },
    /** 查询检验项目列表 */
    getList() {
      getHarmlessPage(this.queryParams).then(res => {
        res.data.records.forEach(item => {
          item.storeTime = changeDate(item.storeTime)
        })
        this.disposalList = res.data.records;
        this.total = res.data.total;
        this.loading = false;
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        harmlessTreatmentId: null,
        startTime: null,
        endTime: null,
        animalType: null
      }
      // this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      if(this.workList.length > 0) {
        this.$set(this.form,"storeLocation",this.workList[0].workshopName)
        // let index = this.workList.filter(item=>item.workshopName=="无害化暂存间");

        // if(index.length>0){
        //   this.$set(this.form,"storeLocation","无害化暂存间")
        // }else{
        //   this.$set(this.form,"storeLocation",this.workList[0].workshopName)
        // }
      }
      if(this.productionList.length > 0) {
        this.$set(this.form,"productName",this.productionList[0].productName)
        // let index = this.productionList.filter(item=>item.productName=="不可食用（修割三腺）");

        // if(index.length>0){

        //   this.$set(this.form,"productName","不可食用（修割三腺）")
        // }else{
        //   this.$set(this.form,"productName",this.productionList[0].productName)
        // }

      }
      this.title = "添加无害化暂存";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getHarmlessDetail(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = false;
        this.title = "修改无害化暂存";
      })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getHarmlessDetail(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = true;
        this.title = "查看无害化暂存";
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        harmlessTreatmentId: null,
        id: null,
        illnessAmount: null,
        storeLocation: null,
        storeTime: changeDate(new Date()),
        unqualifiedWeight: null,
        userName: this.user.nickName,
        animalType: null
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            // 编辑
            editHarmlessPage(this.form).then(res => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            })
          } else {
            // 新增
            addHarmlessPage(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids
      }
      delHarmlessPage(params).then(res => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(() => {
        let params = {
          ids: ids.join(',')
        }
        delHarmlessPage(params).then(res => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        })
      })
    }
  }
}
</script>

<style scoped lang="scss">

</style>
